-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.gearboxInfo = {isReverse = false}
M.brake = 0
M.parkingbrake = 0
M.relevantDevice = nil 
M.clutchRatio = 0


local fl = 0
local gr = 0
local throttle = 0
local throttle_percent = 0
local prop_pitch = 0
local prop_pitch_percent = 0
local airspeed = 0
local overspeed = 0

--local rpm = electrics.values["rpm"]



local min = math.min
local max = math.max
local floor = math.floor



local function onReset()
    fl = 0
    gr = 0
    electrics.values.floats = fl
    electrics.values.cat_gear = gr
    electrics.values.throttleup = 0
    electrics.values.throttledown = 0
    electrics.values.throttlecat = 0
    electrics.values.propPitch = 0
    electrics.values.prop_pitch_up = 0
    electrics.values.prop_pitch_down = 0

 
end


local function floats(VALUE)
    if VALUE == 1 then
        -- Toggle between 1 and 0
        fl = (fl == 1) and 0 or 1
        electrics.values.floats = fl
    end
    --sends ui message informing player of the state of the toggleable, for if they are in first person or unable to see said toggleable
    if fl == 0 then
        gui.message("Floats Retracted", 1, "floatsmessage")
    elseif fl == 1 then
        gui.message("Floats Extended", 1, "floatsmessage")

   
    end
end

local function cat_gear(VALUE)
    if VALUE == 1 then
        -- Toggle between 1 and 0
        gr = (gr == 1) and 0 or 1
        electrics.values.cat_gear = gr
    end
    --sends ui message informing player of the state of the toggleable, for if they are in first person or unable to see said toggleable
    if gr == 0 then
        gui.message("Gear Extended", 1, "gearmessage")
    elseif gr == 1 then
        gui.message("Gear Retracted", 1, "gearmessage")

   
    end
end





local function updateGFX(dt)

     
    
    local throttle = electrics.values.throttlecat or 0

    throttle = min(max(throttle + (electrics.values.throttleup * dt * 0.25) - (electrics.values.throttledown * dt * 0.25), 0), 1)
    electrics.values.throttle = throttle

    electrics.values.throttlecat = throttle


    electrics.values.clutch = 0
    electrics.values.clutchRatio = 1

    --set throttle percent from rounded throttle *100
    throttle_percent = floor(throttle * 100)


    --send constant (or always true) gui message displaying throttle percent, 1 idk what it does, "throttle message" I believe is grouping, check flaps and land 
    --function to see grouping there allowing throttle message to show without overlapping other gui messages
      gui.message(throttle_percent .."% Throttle", 1, "throttlemessage")


     

    local prop_pitch = electrics.values.propPitch or 0

    prop_pitch = min(max(prop_pitch + (electrics.values.prop_pitch_up * dt * 0.25) - (electrics.values.prop_pitch_down * dt * 0.25), 0), 1)
    electrics.values.propPitch = prop_pitch

    electrics.values.propPitch = prop_pitch


   

    --set throttle percent from rounded throttle *100
    prop_pitch_percent = floor(prop_pitch * 100)


    --send constant (or always true) gui message displaying throttle percent, 1 idk what it does, "throttle message" I believe is grouping, check flaps and land 
    --function to see grouping there allowing throttle message to show without overlapping other gui messages
      gui.message(prop_pitch_percent .."% Prop Pitch", 1, "proppitchmessage")



      if electrics.values["rpm"] >= 1500 then

      electrics.values.prop_blur_l = 1
      electrics.values.prop_blur_r = 1

      else
        electrics.values.prop_blur_l = 0
        electrics.values.prop_blur_r = 0

    end
    
end






M.onInit    = onReset
M.onReset   = onReset
M.floats    = floats
M.cat_gear   = cat_gear
M.updateGFX = updateGFX


return M